<?php
/* 
	[ComicGlass用ファイル一覧生成スクリプト(Shift-JIS)]
	
	このスクリプトはiOSアプリ「おやゆびでお」の開発者 古田一義さんが作成したものを
	マキさん(http://www.relativetruth.net/)がComicGlass向けに修正したものをベースにしています。
	
	このスクリプトについてのご質問はComicGlassサポートページまたはtwitter(@rhotta)まで。
	
	
	[更新履歴]
	12/04/24		スクリプトをHTTPサーバのルートに置いていない時の動作を改善しました(R.Hotta)
	13/01/01		Shift-JIS向け変更(R.Hotta)
	
	
 */
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<?
	 $path = urldecode($_GET['path']);

	 if ($path=="") {$path="./";}
	 
	 //ディレクトリトラバーサルを防止
	 $realpath = realpath($path);
	 $bookpath = realpath("./");
	 if(strpos($realpath, $bookpath, 0) !== 0)
	 {
	 	$path="./";
	 }
	$path_utf8 = mb_convert_encoding($path, 'utf8', 'sjis-win');
?>
<html>
 <head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title><?=$path;?></title>
 </head>
<body>

<h3><?=$path_utf8;?></h3>
<ul>
<?
//ファイル一覧を取得
	$d = dir("".$path);
//ファイル名でソートするため配列に移す。
	$array_file = array();
	while ($file_name = $d->read()) {
		if (is_dir($path.$file_name)) {
			$file_mark = "0".$file_name;
		} else {
			$file_mark = "1".$file_name;
		}
		array_push($array_file, $file_mark);
	}
	sort($array_file); //ソート実行

//	ファイル一覧を出力
	foreach ($array_file as &$entry) {
		$entry = substr($entry,1, strlen($entry)-1);
		$entry_utf8 = mb_convert_encoding($entry, 'utf8', 'sjis-win');
		$folderpath = str_replace("%2F","/", rawurlencode($path.$entry));
		$fullpath = str_replace("./", "", "$folderpath");
		$scriptdir = dirname($_SERVER['SCRIPT_NAME']);
		if(eregi('/$',$scriptdir)){
			$filebasepath = $scriptdir  . $fullpath;
		}else{
		
			$filebasepath = $scriptdir . "/" . $fullpath;
		}
		if (is_dir($path.$entry)) {
			if ($entry==".") {
			} elseif ($entry=="..") {
		  	} else {
				if (substr($entry,0,1) != ".") {
					
					echo "<li type=\"circle\"><a href=\"?path=".rawurlencode($folderpath)."/\" booktitle=" .$entry_utf8. ">".$entry_utf8."</a></li>\n";
				}
		 	}

		//不可視ファイルは除外
		} elseif (substr($entry,0,1) == ".") {

		//表示する拡張子
		} elseif (eregi(
		'\.gif$|\.png$|\.jpg$|\.jpeg$|\.tif$|\.tiff$|\.zip$|\.rar$|\.cbz$|\.cbr$|\.bmp$|\.pdf$|\.cgt$'
		,$entry)) {
			$filebasepath_utf8 = rawurlencode(mb_convert_encoding(rawurldecode($filebasepath), 'utf8', 'sjis-win'));
			$filebasepath_utf8 = str_replace("%2F","/", $filebasepath_utf8);
			echo "<li><a href=\"".$filebasepath_utf8."\">".$entry_utf8."</a></li>\n";
		}
	}
	   $d->close();
?>
</ul>
</body>
</html>
